/*
 * Copyright (C) 2002,2009 LAAS/CNRS
 *
 * Matthieu Herrb - Mon Apr 15 2002
 */
#ifndef _RFLEXCLIENT_H
#define _RFLEXCLIENT_H

#define INCREMENT(id) \
    do { \
	(id)++; \
	if ((id) > 254) (id) = 0;\
    } while (0)

extern int sysLcdDumpRpl(struct reflex *reflex, int rv, unsigned char id,
			 int ts, unsigned char row, unsigned char nbytes,
			 unsigned char *data);
extern int sysStatusRpl(struct reflex *reflex, int rv, unsigned char id,
			int ts, int volts, unsigned char brake);
extern int sysUnknownRpl(struct reflex *reflex, unsigned char id,
			 unsigned char size, unsigned char *buffer,
			 unsigned char opcode);
extern int motAxisSystemRpt(struct reflex *reflex, unsigned char id,
			    int ts, unsigned char axis, int pos, int vel,
			    int acc, int trq);
extern int motAxisGetSystemRpl(struct reflex *reflex, int rv,
			       unsigned char id, int ts, unsigned char axis,
			       int pos, int vel, int acc, int trq);
extern int motAxisGetModelRpl(struct reflex *reflex, int rv,
			      unsigned char id, int ts, unsigned char axis,
			      int pos, int vel, int acc, int trq);
extern int motAxisGetTargetRpl(struct reflex *reflex, int rv,
			       unsigned char id, int ts, unsigned char axis,
			       int pos, int vel, int acc, int trq);
extern int motAxisSetDirRpl(struct reflex *reflex, int rv, unsigned char id,
			    int ts, unsigned char axis);
extern int motSetDefaultsRpl(struct reflex *reflex, int rv,
			     unsigned char id, int ts);
extern int motBrakeSetRpl(struct reflex *reflex, int rv, unsigned char id,
			  int ts);
extern int motBrakeReleaseRpl(struct reflex *reflex, int rv,
			      unsigned char id, int ts);
extern int motSetSystemRptRpl(struct reflex *reflex, int rv,
			      unsigned char id, int ts);
extern int motUnknownRpl(struct reflex *reflex, unsigned char id,
			 unsigned char size, unsigned char *buffer,
			 unsigned char opcode);
extern int jstkGetStateRpl(struct reflex *reflex, int rv, unsigned char id,
			   int ts, int x, int y, unsigned char buttons);
extern int jstkUnknownRpl(struct reflex *reflex, unsigned char id,
			  unsigned char size, unsigned char *buffer,
			  unsigned char opcode);
extern int sonarRptRpl(struct reflex *reflex, int rv, unsigned char id,
		       int ts);
extern int sonarGetUpdateRpl(struct reflex *reflex, int rv, unsigned char id,
			     int ts, int count, unsigned char *sonarId,
			     unsigned short *sonarValue);
extern int sonarRpt(struct reflex *reflex, unsigned char id, int ts,
		    int count, unsigned char *sonarId,
		    unsigned short *sonarValue);
extern int sonarUnknownRpl(struct reflex *reflex, unsigned char id,
			   unsigned char size, unsigned char *buffer,
			   unsigned char opcode);

#ifdef B21R
extern int dioUpdateRpl(struct reflex *reflex, int rv, unsigned char id,
			int ts, int count);
extern int dioUpdate(struct reflex *reflex, unsigned char id, int ts,
		     unsigned char netId, unsigned char offset,
		     unsigned char state);
extern int dioRptRpl(struct reflex *reflex, int rv, unsigned char id, int ts);
extern int dioRpt(struct reflex *reflex, unsigned char id, int ts,
		  unsigned char netId, unsigned char offset,
		  unsigned char state);
extern int dioUnknownRpl(struct reflex *reflex, unsigned char id,
			 unsigned char size, unsigned char *buffer,
			 unsigned char opcode);
#endif /* B21R */

extern int defaultHandlePort(struct reflex *reflex, int size,
			     unsigned char *buffer, unsigned char port,
			     unsigned char id, unsigned char opcode);

int readAttitudeEstimation();
#endif
